// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rcss3d_agent_msgs:msg/Hear.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rcss3d_agent_msgs/msg/hear.hpp"


#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__HEAR__STRUCT_HPP_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__HEAR__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__rcss3d_agent_msgs__msg__Hear __attribute__((deprecated))
#else
# define DEPRECATED__rcss3d_agent_msgs__msg__Hear __declspec(deprecated)
#endif

namespace rcss3d_agent_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Hear_
{
  using Type = Hear_<ContainerAllocator>;

  explicit Hear_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->team = "";
      this->time = 0.0f;
      this->self = false;
      this->message = "";
    }
  }

  explicit Hear_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : team(_alloc),
    message(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->team = "";
      this->time = 0.0f;
      this->self = false;
      this->message = "";
    }
  }

  // field types and members
  using _team_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _team_type team;
  using _time_type =
    float;
  _time_type time;
  using _self_type =
    bool;
  _self_type self;
  using _direction_type =
    rosidl_runtime_cpp::BoundedVector<float, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>>;
  _direction_type direction;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _message_type message;

  // setters for named parameter idiom
  Type & set__team(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->team = _arg;
    return *this;
  }
  Type & set__time(
    const float & _arg)
  {
    this->time = _arg;
    return *this;
  }
  Type & set__self(
    const bool & _arg)
  {
    this->self = _arg;
    return *this;
  }
  Type & set__direction(
    const rosidl_runtime_cpp::BoundedVector<float, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>> & _arg)
  {
    this->direction = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->message = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rcss3d_agent_msgs::msg::Hear_<ContainerAllocator> *;
  using ConstRawPtr =
    const rcss3d_agent_msgs::msg::Hear_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rcss3d_agent_msgs::msg::Hear_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rcss3d_agent_msgs::msg::Hear_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rcss3d_agent_msgs::msg::Hear_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rcss3d_agent_msgs::msg::Hear_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rcss3d_agent_msgs::msg::Hear_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rcss3d_agent_msgs::msg::Hear_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rcss3d_agent_msgs::msg::Hear_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rcss3d_agent_msgs::msg::Hear_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rcss3d_agent_msgs__msg__Hear
    std::shared_ptr<rcss3d_agent_msgs::msg::Hear_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rcss3d_agent_msgs__msg__Hear
    std::shared_ptr<rcss3d_agent_msgs::msg::Hear_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Hear_ & other) const
  {
    if (this->team != other.team) {
      return false;
    }
    if (this->time != other.time) {
      return false;
    }
    if (this->self != other.self) {
      return false;
    }
    if (this->direction != other.direction) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    return true;
  }
  bool operator!=(const Hear_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Hear_

// alias to use template instance with default allocator
using Hear =
  rcss3d_agent_msgs::msg::Hear_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rcss3d_agent_msgs

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__HEAR__STRUCT_HPP_
