// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rcss3d_agent_msgs:msg/UniversalJointPos.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rcss3d_agent_msgs/msg/universal_joint_pos.h"


#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__UNIVERSAL_JOINT_POS__STRUCT_H_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__UNIVERSAL_JOINT_POS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'name'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/UniversalJointPos in the package rcss3d_agent_msgs.
/**
  * Information about the two angles of the correponding two axis universal joint. Zero degrees
  * corresponds to straightly aligned bodies.
 */
typedef struct rcss3d_agent_msgs__msg__UniversalJointPos
{
  /// The name of the corresponding universal joint
  rosidl_runtime_c__String name;
  /// Current position angle of the first axis in degrees
  float ax1;
  /// Current position angle of the second axis in degrees
  float ax2;
} rcss3d_agent_msgs__msg__UniversalJointPos;

// Struct for a sequence of rcss3d_agent_msgs__msg__UniversalJointPos.
typedef struct rcss3d_agent_msgs__msg__UniversalJointPos__Sequence
{
  rcss3d_agent_msgs__msg__UniversalJointPos * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rcss3d_agent_msgs__msg__UniversalJointPos__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__UNIVERSAL_JOINT_POS__STRUCT_H_
