// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rcss3d_agent_msgs:msg/Percept.idl
// generated code does not contain a copyright notice
#include "rcss3d_agent_msgs/msg/detail/percept__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `gyro_rates`
#include "rcss3d_agent_msgs/msg/detail/gyro_rate__functions.h"
// Member `hinge_joints`
#include "rcss3d_agent_msgs/msg/detail/hinge_joint_pos__functions.h"
// Member `universal_joints`
#include "rcss3d_agent_msgs/msg/detail/universal_joint_pos__functions.h"
// Member `force_resistances`
#include "rcss3d_agent_msgs/msg/detail/force_resistance__functions.h"
// Member `accelerometers`
#include "rcss3d_agent_msgs/msg/detail/accelerometer__functions.h"
// Member `vision`
#include "rcss3d_agent_msgs/msg/detail/vision__functions.h"
// Member `game_state`
#include "rcss3d_agent_msgs/msg/detail/game_state__functions.h"
// Member `agent_state`
#include "rcss3d_agent_msgs/msg/detail/agent_state__functions.h"
// Member `hears`
#include "rcss3d_agent_msgs/msg/detail/hear__functions.h"

bool
rcss3d_agent_msgs__msg__Percept__init(rcss3d_agent_msgs__msg__Percept * msg)
{
  if (!msg) {
    return false;
  }
  // gyro_rates
  if (!rcss3d_agent_msgs__msg__GyroRate__Sequence__init(&msg->gyro_rates, 0)) {
    rcss3d_agent_msgs__msg__Percept__fini(msg);
    return false;
  }
  // hinge_joints
  if (!rcss3d_agent_msgs__msg__HingeJointPos__Sequence__init(&msg->hinge_joints, 0)) {
    rcss3d_agent_msgs__msg__Percept__fini(msg);
    return false;
  }
  // universal_joints
  if (!rcss3d_agent_msgs__msg__UniversalJointPos__Sequence__init(&msg->universal_joints, 0)) {
    rcss3d_agent_msgs__msg__Percept__fini(msg);
    return false;
  }
  // force_resistances
  if (!rcss3d_agent_msgs__msg__ForceResistance__Sequence__init(&msg->force_resistances, 0)) {
    rcss3d_agent_msgs__msg__Percept__fini(msg);
    return false;
  }
  // accelerometers
  if (!rcss3d_agent_msgs__msg__Accelerometer__Sequence__init(&msg->accelerometers, 0)) {
    rcss3d_agent_msgs__msg__Percept__fini(msg);
    return false;
  }
  // vision
  if (!rcss3d_agent_msgs__msg__Vision__Sequence__init(&msg->vision, 0)) {
    rcss3d_agent_msgs__msg__Percept__fini(msg);
    return false;
  }
  // game_state
  if (!rcss3d_agent_msgs__msg__GameState__init(&msg->game_state)) {
    rcss3d_agent_msgs__msg__Percept__fini(msg);
    return false;
  }
  // agent_state
  if (!rcss3d_agent_msgs__msg__AgentState__Sequence__init(&msg->agent_state, 0)) {
    rcss3d_agent_msgs__msg__Percept__fini(msg);
    return false;
  }
  // hears
  if (!rcss3d_agent_msgs__msg__Hear__Sequence__init(&msg->hears, 0)) {
    rcss3d_agent_msgs__msg__Percept__fini(msg);
    return false;
  }
  return true;
}

void
rcss3d_agent_msgs__msg__Percept__fini(rcss3d_agent_msgs__msg__Percept * msg)
{
  if (!msg) {
    return;
  }
  // gyro_rates
  rcss3d_agent_msgs__msg__GyroRate__Sequence__fini(&msg->gyro_rates);
  // hinge_joints
  rcss3d_agent_msgs__msg__HingeJointPos__Sequence__fini(&msg->hinge_joints);
  // universal_joints
  rcss3d_agent_msgs__msg__UniversalJointPos__Sequence__fini(&msg->universal_joints);
  // force_resistances
  rcss3d_agent_msgs__msg__ForceResistance__Sequence__fini(&msg->force_resistances);
  // accelerometers
  rcss3d_agent_msgs__msg__Accelerometer__Sequence__fini(&msg->accelerometers);
  // vision
  rcss3d_agent_msgs__msg__Vision__Sequence__fini(&msg->vision);
  // game_state
  rcss3d_agent_msgs__msg__GameState__fini(&msg->game_state);
  // agent_state
  rcss3d_agent_msgs__msg__AgentState__Sequence__fini(&msg->agent_state);
  // hears
  rcss3d_agent_msgs__msg__Hear__Sequence__fini(&msg->hears);
}

bool
rcss3d_agent_msgs__msg__Percept__are_equal(const rcss3d_agent_msgs__msg__Percept * lhs, const rcss3d_agent_msgs__msg__Percept * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // gyro_rates
  if (!rcss3d_agent_msgs__msg__GyroRate__Sequence__are_equal(
      &(lhs->gyro_rates), &(rhs->gyro_rates)))
  {
    return false;
  }
  // hinge_joints
  if (!rcss3d_agent_msgs__msg__HingeJointPos__Sequence__are_equal(
      &(lhs->hinge_joints), &(rhs->hinge_joints)))
  {
    return false;
  }
  // universal_joints
  if (!rcss3d_agent_msgs__msg__UniversalJointPos__Sequence__are_equal(
      &(lhs->universal_joints), &(rhs->universal_joints)))
  {
    return false;
  }
  // force_resistances
  if (!rcss3d_agent_msgs__msg__ForceResistance__Sequence__are_equal(
      &(lhs->force_resistances), &(rhs->force_resistances)))
  {
    return false;
  }
  // accelerometers
  if (!rcss3d_agent_msgs__msg__Accelerometer__Sequence__are_equal(
      &(lhs->accelerometers), &(rhs->accelerometers)))
  {
    return false;
  }
  // vision
  if (!rcss3d_agent_msgs__msg__Vision__Sequence__are_equal(
      &(lhs->vision), &(rhs->vision)))
  {
    return false;
  }
  // game_state
  if (!rcss3d_agent_msgs__msg__GameState__are_equal(
      &(lhs->game_state), &(rhs->game_state)))
  {
    return false;
  }
  // agent_state
  if (!rcss3d_agent_msgs__msg__AgentState__Sequence__are_equal(
      &(lhs->agent_state), &(rhs->agent_state)))
  {
    return false;
  }
  // hears
  if (!rcss3d_agent_msgs__msg__Hear__Sequence__are_equal(
      &(lhs->hears), &(rhs->hears)))
  {
    return false;
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__Percept__copy(
  const rcss3d_agent_msgs__msg__Percept * input,
  rcss3d_agent_msgs__msg__Percept * output)
{
  if (!input || !output) {
    return false;
  }
  // gyro_rates
  if (!rcss3d_agent_msgs__msg__GyroRate__Sequence__copy(
      &(input->gyro_rates), &(output->gyro_rates)))
  {
    return false;
  }
  // hinge_joints
  if (!rcss3d_agent_msgs__msg__HingeJointPos__Sequence__copy(
      &(input->hinge_joints), &(output->hinge_joints)))
  {
    return false;
  }
  // universal_joints
  if (!rcss3d_agent_msgs__msg__UniversalJointPos__Sequence__copy(
      &(input->universal_joints), &(output->universal_joints)))
  {
    return false;
  }
  // force_resistances
  if (!rcss3d_agent_msgs__msg__ForceResistance__Sequence__copy(
      &(input->force_resistances), &(output->force_resistances)))
  {
    return false;
  }
  // accelerometers
  if (!rcss3d_agent_msgs__msg__Accelerometer__Sequence__copy(
      &(input->accelerometers), &(output->accelerometers)))
  {
    return false;
  }
  // vision
  if (!rcss3d_agent_msgs__msg__Vision__Sequence__copy(
      &(input->vision), &(output->vision)))
  {
    return false;
  }
  // game_state
  if (!rcss3d_agent_msgs__msg__GameState__copy(
      &(input->game_state), &(output->game_state)))
  {
    return false;
  }
  // agent_state
  if (!rcss3d_agent_msgs__msg__AgentState__Sequence__copy(
      &(input->agent_state), &(output->agent_state)))
  {
    return false;
  }
  // hears
  if (!rcss3d_agent_msgs__msg__Hear__Sequence__copy(
      &(input->hears), &(output->hears)))
  {
    return false;
  }
  return true;
}

rcss3d_agent_msgs__msg__Percept *
rcss3d_agent_msgs__msg__Percept__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Percept * msg = (rcss3d_agent_msgs__msg__Percept *)allocator.allocate(sizeof(rcss3d_agent_msgs__msg__Percept), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rcss3d_agent_msgs__msg__Percept));
  bool success = rcss3d_agent_msgs__msg__Percept__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rcss3d_agent_msgs__msg__Percept__destroy(rcss3d_agent_msgs__msg__Percept * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rcss3d_agent_msgs__msg__Percept__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rcss3d_agent_msgs__msg__Percept__Sequence__init(rcss3d_agent_msgs__msg__Percept__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Percept * data = NULL;

  if (size) {
    data = (rcss3d_agent_msgs__msg__Percept *)allocator.zero_allocate(size, sizeof(rcss3d_agent_msgs__msg__Percept), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rcss3d_agent_msgs__msg__Percept__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rcss3d_agent_msgs__msg__Percept__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rcss3d_agent_msgs__msg__Percept__Sequence__fini(rcss3d_agent_msgs__msg__Percept__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rcss3d_agent_msgs__msg__Percept__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rcss3d_agent_msgs__msg__Percept__Sequence *
rcss3d_agent_msgs__msg__Percept__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Percept__Sequence * array = (rcss3d_agent_msgs__msg__Percept__Sequence *)allocator.allocate(sizeof(rcss3d_agent_msgs__msg__Percept__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rcss3d_agent_msgs__msg__Percept__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rcss3d_agent_msgs__msg__Percept__Sequence__destroy(rcss3d_agent_msgs__msg__Percept__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rcss3d_agent_msgs__msg__Percept__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rcss3d_agent_msgs__msg__Percept__Sequence__are_equal(const rcss3d_agent_msgs__msg__Percept__Sequence * lhs, const rcss3d_agent_msgs__msg__Percept__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rcss3d_agent_msgs__msg__Percept__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__Percept__Sequence__copy(
  const rcss3d_agent_msgs__msg__Percept__Sequence * input,
  rcss3d_agent_msgs__msg__Percept__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rcss3d_agent_msgs__msg__Percept);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rcss3d_agent_msgs__msg__Percept * data =
      (rcss3d_agent_msgs__msg__Percept *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rcss3d_agent_msgs__msg__Percept__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rcss3d_agent_msgs__msg__Percept__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rcss3d_agent_msgs__msg__Percept__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
